"""
Auteur : Patrick WAMPÉ
Livre : Machine Learning et Deep Learning
Des bases à la conception avancée d’algorithmes
Chapitre : 8
"""

# FONCTIONS

def HelloWorld():
    for i in range(1, 6):
        print("Bonjour le monde !") 

HelloWorld()

def procedureAvecPlusieursParametres(message, valeurDeDebut, valeurDeFin):
    for i in range(valeurDeDebut, valeurDeFin):
        print(message)

procedureAvecPlusieursParametres("Bonjour le monde !", 1, 6)

def carre(x):
    return x * x

print(carre(2) + 38)

# Imbrication de fonctions
def carre(x):
    return x * x

print("Le carré du carré du carré de 2 est :", carre(carre(carre(2))))

# Imbrication de carrés
def plusieurs_valeurs(x):
    une_autre_variable = "Une phrase quelconque"
    carre =x*x
    cube = x * x * x
    return carre, cube

print("La fonction renvoie le carré et ensuite le cube du nombre passé en paramètre :", plusieurs_valeurs(2))
# Cette fonction renverra donc 4 et ensuite 8

# PROGRAMMATION ORIENTÉ OBJET

variable = "un objet"
print(variable.upper())

class voiture:
    """ Une classe commence par une fonction appelée constructeur.
        Cette fonction contient les attributs de l'objet.
        Elle se lance automatiquement quand on crée un nouvel objet.
        Chaque méthode d'un objet doit commencer par le mot-clé self.
        Il signifie que nous nous trouvons dans le contexte d'une classe"""
    def __init__(self, marque, modele, prix, couleur, annee_de_construction, etat = "À l'arrêt", vitesse = 0):
        self.marque = marque
        self.modele = modele
        self.prix = prix
        self.couleur = couleur
        self.annee_de_construction = annee_de_construction
        self.etat = etat
        self.vitesse = vitesse
        # Nous créons ensuite plusieurs méthodes
        # Certaines méthodes vont modifier la valeur de certains attributs
    
    def demarrer(self):
        if self.etat == "À l'arrêt":
            self.etat = "Démarré"
            print("Le moteur tourne !")
        else:
            print("Le moteur tourne déjà")

    def couper_le_moteur(self):
        if self.etat == "Démarré":
            self.etat = "À l'arrêt"
            self.vitesse = 0
            print("Le moteur est arrêté !")
        else:
            print("Le moteur est déjà à l'arrêt")

    def accelerer(self, vitesse): 
        if self.etat == "Démarré":
            self.vitesse += vitesse
            print('La vitesse est de', self.vitesse, "km/h")
        else:
            print("Il faut d'abord démarrer la voiture pour accélérer")

    def freiner(self):
        if self.vitesse < 10:
            self.vitesse = 0
            print('La vitesse est de', self.vitesse, "km/h")
        else:
            self.vitesse = self.vitesse - 10
            print('La vitesse est de', self.vitesse, "km/h")

    def klaxonner(self): 
        print("TuuuuuuTuuuuuuu !!!")

    def details_voiture(self):
        print("Marque : {} \nModèle : {} \nPrix : {} \nCouleur : \nAnnée de construction : {} \nÉtat : {} \nVitesse : {} Km/H".format(self.marque,
        self.modele, self.prix, self.couleur, self.annee_de_construction,
        self.etat, self.vitesse))

# Le code ci-après crée un objet qui est utilisé au travers de plusieurs méthodes
ma_voiture = voiture("Renaud", "Clio", 2500, "rouge", 2010) 
ma_voiture.details_voiture()
ma_voiture.accelerer(20)
ma_voiture.demarrer()
ma_voiture.klaxonner()
ma_voiture.freiner()
ma_voiture.couper_le_moteur()
